﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="SharePrices.aspx.vb" Inherits="SharePrices.SharePrices" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Steve's share prices</title>
    <link href="SharePricesStyles.css" rel="stylesheet" type="text/css" />
    <link href="SharePricesModal.css" rel="stylesheet" type="text/css" />
    <link href="jquery-ui.css" rel="stylesheet" type="text/css" />
    <script src="scripts/jquery-3.5.1.min.js" type="text/javascript"></script>
    <script src="scripts/jquery-ui.min.js" type="text/javascript"></script>
    <script src="scripts/jquery.flot.js" type="text/javascript"></script>
    <script src="scripts/jquery.flot.crosshair.js" type="text/javascript"></script>
    <script src="scripts/jquery.flot.time.min.js" type="text/javascript"></script>
    <script src="scripts/jquery.flot.pie.js" type="text/javascript"></script>
    <script src="scripts/js.cookie-2.2.1.min.js" type="text/javascript"></script>
    <script src="scripts/tablesorter/jquery.tablesorter.js" type="text/javascript"></script>
    <script src="scripts/tablesorter/jquery.tablesorter.widgets.js" type="text/javascript"></script>
    <script src="scripts/SharePrices.js" type="text/javascript"></script>
    <script src="scripts/FlotGaps.js" type="text/javascript"></script>
</head>
<body>
  <div class="navbar">
    <a id="navCharts" class="activenav" onclick="showTab(this)" data-div="chartDiv">Charts</a>
    <a id="navCurrentHoldings" onclick="showTab(this);" data-div="holdingsDiv">Current Holdings</a>
    <a id="navAnal" onclick="showTab(this);" data-div="analDiv">Share Analysis</a>
    <label for="showBreakevenLine">Show breakeven line</label><input type="checkbox" name="showBreakevenLine" id="showBreakevenLine" onclick="handleClick(this)"/>
    <label for="displayAsPercent">Display as percent</label><input type="checkbox" name="displayAsPercent" id="displayAsPercent" onclick="handleClick(this)"/>
    <label for="showPreviousHoldings">Show previous holdings</label><input type="checkbox" name="showPreviousHoldings" id="showPreviousHoldings" onclick="handleClick(this)"/>
    <button onclick="showModalDialog_AddInstrument()">Add Instrument</button>
  </div>
  <div class="main" id="mainDiv">
    <div id="chartDiv">Charts</div>
    <div id="holdingsDiv">Current Holdings</div>
    <div id="analDiv">Share Analysis</div>
  </div>
  <div id="modalDialog" class="modal">
    <div class="modal-content">
      <div>
        <!--<span class="modal-title">Title<span class="close">&times;</span></span> !-->
        <table class="modal-title"><tr><td id="modalTitle">Title</td><td class="close">&times;</td></tr></table>
      </div>
      <br />
      <div id="modalContentDiv"></div>
    </div>
  </div>
  <div id="chartTooltip" class="chart-tooltip"></div>
  <script>
    function initPage() {
      let c = Cookies.get('activeTab');
      let t = $('#' + c);
      if (t && t.length > 0) {
        showTab(t[0]);
      } else {
        showTab($('#navCharts')[0]);
      }

      c = Cookies.get('showBreakevenLine');
      $("#showBreakevenLine").prop('checked', (c == 'true') ? true : false);
      c = Cookies.get('displayAsPercent');
      $("#displayAsPercent").prop('checked', (c == 'true') ? true : false);
      c = Cookies.get('showPreviousHoldings');
      $("#showPreviousHoldings").prop('checked', (c == 'true') ? true : false);
      
      getInstruments();
    }
    function showTab(tab) {
      $('.navbar>a').removeClass('activenav');
      $('#' + tab.id).addClass('activenav');

      $('#mainDiv>div').removeClass('activetab').addClass('inactivetab');
      $('#' + $(tab).attr('data-div')).removeClass('inactivetab').addClass('activetab');

      //Cookies.set('activeTab', tab.id);
      Cookies.set('activeTab', tab.id, {'sameSite': 'strict'});
    }
    function handleClick(checkbox) {
      //Cookies.set(checkbox.id, checkbox.checked);
      Cookies.set(checkbox.id, checkbox.checked, {'sameSite': 'strict'});
      
      switch (checkbox.id) {
        case 'showBreakevenLine':
          redrawAllSharesCharts();
          break;
        case 'displayAsPercent':
          redrawAllSharesCharts();
          break;
        case 'showPreviousHoldings':
          redrawAllSharesCharts();
          break;
      }
    }
    $(document).ready(initPage());
  </script>
</body>
</html>
