﻿Imports System.Web.Services
Imports SharePrices.SharePricesUtils

Public Class SharePrices
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Debug.Print("SharePrices - Page load - " + Now().ToString("yyyy-MM-dd HH:mm:ss"))
    End Sub

    <WebMethod()>
    Public Shared Sub GetInstruments()
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetInstruments webmethod")

        Dim responseText As String = DataAccessLayer.GetInstruments()
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub AddInstrument(Symbol As String, FullName As String)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.AddInstrument webmethod: " + Symbol + ", " + FullName)

        Dim responseText As String = DataAccessLayer.AddInstrument(Symbol, FullName)
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub AddHolding(AccountName As String, Symbol As String, NoUnits As Integer, PurchasePricePerUnit As Double, PurchaseDate As Int64)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.AddHolding webmethod: " + AccountName + ", " + Symbol)

        Dim responseText As String = DataAccessLayer.AddHolding(AccountName, Symbol, NoUnits, PurchasePricePerUnit, PurchaseDate)
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub GetAllDailyData(startDate As Int64, endDate As Int64)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetAllDailyData webmethod: """ + FromEpochTime(startDate).ToString("yyyy-MM-dd HH:mm:ss") + """, """ + FromEpochTime(endDate).ToString("yyyy-MM-dd HH:mm:ss") + """")

        Dim responseText As String = DataAccessLayer.GetAllDailyData(FromEpochTime(startDate), FromEpochTime(endDate))
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub GetDailyData(Symbol As String, startDate As Int64, endDate As Int64)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetDailyData webmethod: """ + Symbol + """, """ + FromEpochTime(startDate).ToString("yyyy-MM-dd HH:mm:ss") + """, """ + FromEpochTime(endDate).ToString("yyyy-MM-dd HH:mm:ss") + """")

        Dim responseText As String = DataAccessLayer.GetDailyData(Symbol, FromEpochTime(startDate), FromEpochTime(endDate))
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub GetAllIntradayData(startDate As Int64, endDate As Int64)
        Dim startDT As Date = Now()
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetAllIntradayData webmethod: """ + FromEpochTime(startDate).ToString("yyyy-MM-dd HH:mm:ss") + """, """ + FromEpochTime(endDate).ToString("yyyy-MM-dd HH:mm:ss") + """")

        Dim responseText As String = DataAccessLayer.GetAllIntradayData(FromEpochTime(startDate), FromEpochTime(endDate))
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
        Dim endDT As Date = Now()
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetAllIntradayData completed. Duration = " + DateDiff(DateInterval.Second, startDate, endDT).ToString())
    End Sub

    <WebMethod()>
    Public Shared Sub GetIntradayData(Symbol As String, startDate As Int64, endDate As Int64)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.GetIntradayData webmethod: """ + Symbol + """, """ + FromEpochTime(startDate).ToString("yyyy-MM-dd HH:mm:ss") + """, """ + FromEpochTime(endDate).ToString("yyyy-MM-dd HH:mm:ss") + """")

        Dim responseText As String = DataAccessLayer.GetIntradayData(Symbol, FromEpochTime(startDate), FromEpochTime(endDate))
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub SubmitDailyData(Symbol As String, DailyPrices As List(Of DataAccessLayer.PriceData))
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.SubmitDailyData webmethod: " + Symbol)

        Dim responseText As String = DataAccessLayer.InsertDailyData(Symbol, DailyPrices)
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub SubmitIntradayData(Symbol As String, DailyPrices As List(Of DataAccessLayer.PriceData))
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.SubmitIntradayData webmethod: " + Symbol)

        Dim responseText As String = DataAccessLayer.InsertIntradayData(Symbol, DailyPrices)
        If responseText = "" Then responseText = "[]"
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub DeleteHolding(HoldingID As Integer)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.DeleteHolding webmethod: " + HoldingID.ToString())

        Dim responseText As String = DataAccessLayer.DeleteHolding(HoldingID)
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub FetchYahooFinanceIntraday(Symbol As String)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.FetchYahooFinanceIntraday webmethod: " + Symbol)

        Dim webClient As New System.Net.WebClient
        Dim responseText As String = webClient.DownloadString("https://query1.finance.yahoo.com/v8/finance/chart/" + Symbol + "?region=GB&lang=en-GB&includePrePost=false&interval=1h&range=1mo&.tsrc=finance")
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub FetchYahooFinanceDaily(Symbol As String)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.FetchYahooFinanceDaily webmethod: " + Symbol)

        Dim webClient As New System.Net.WebClient
        Dim responseText As String = webClient.DownloadString("https://query1.finance.yahoo.com/v8/finance/chart/" + Symbol + "?region=GB&lang=en-GB&includePrePost=false&interval=1d&range=6mo&.tsrc=finance")
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub FetchYahooFinanceSingleDay(Symbol As String)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.FetchYahooFinanceSingleDay webmethod: " + Symbol)

        Dim webClient As New System.Net.WebClient
        Dim responseText As String = webClient.DownloadString("https://query1.finance.yahoo.com/v8/finance/chart/" + Symbol + "?region=GB&lang=en-GB&includePrePost=false&interval=2m&range=1d&corsDomain=uk.finance.yahoo.com&.tsrc=finance")
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub

    <WebMethod()>
    Public Shared Sub SearchYahooFinanceShares(SearchString As String)
        Debug.Print(Now().ToString("yyyy-MM-dd HH:mm:ss") + " - SharePrices.SearchYahooFinanceShares webmethod: " + SearchString)

        Dim webClient As New System.Net.WebClient
        Dim responseText As String = webClient.DownloadString("https://query1.finance.yahoo.com/v1/finance/search?q=" + SearchString + "&quotesCount=6&newsCount=0&enableFuzzyQuery=false&quotesQueryId=tss_match_phrase_query&multiQuoteQueryId=multi_quote_single_token_query&newsQueryId=news_ss_symbols&enableCb=false&enableNavLinks=false&vespaNewsTimeoutMs=600")
        SetResponseAndCompleteRequest(HttpContext.Current, "application/json", responseText)
    End Sub
    
End Class